"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Nav_1 = require("./Nav");
var NavGroupState;
(function (NavGroupState) {
    NavGroupState["expanded"] = "expanded";
    NavGroupState["collapsed"] = "collapsed";
})(NavGroupState || (NavGroupState = {}));
exports.NavGroup = function (props) {
    var children = props.children, onClick = props.onClick, others = __rest(props, ["children", "onClick"]);
    var _a = React.useState(NavGroupState.collapsed), state = _a[0], setState = _a[1];
    var onHandleClick = function () {
        setState(function (currentState) {
            return currentState === NavGroupState.collapsed ? NavGroupState.expanded : NavGroupState.collapsed;
        });
    };
    // we would want to render the main items but
    // not the children
    var navChildren = [];
    var nonNavChildren = [];
    React.Children.toArray(children).forEach(function (child) {
        var childEl = child;
        if (childEl.type === Nav_1.Nav) {
            navChildren.push(child);
        }
        else {
            nonNavChildren.push(child);
        }
    });
    return (React.createElement("div", __assign({}, others, { onClick: onHandleClick }),
        React.createElement("div", null, nonNavChildren),
        React.createElement("div", { style: { display: state === NavGroupState.collapsed ? 'none' : 'block' } }, navChildren)));
};
