"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Nav_1 = require("./Nav");
exports.Nav = Nav_1.Nav;
exports.NavContext = Nav_1.NavContext;
exports.SideNavActionContext = React.createContext(null);
exports.SideNavContext = React.createContext(null);
exports.SideNav = function (props) {
    var _a = React.useState({ selection: '' }), state = _a[0], setState = _a[1];
    var onSelectionPathSelected = function (path) {
        setState(function (currentState) { return (__assign({}, currentState, { selection: path })); });
    };
    React.useEffect(function () {
        if (state.selection && props.onSelection) {
            props.onSelection(state.selection);
        }
    }, [state.selection, props.onSelection]);
    return (React.createElement(exports.SideNavContext.Provider, { value: state },
        React.createElement(exports.SideNavActionContext.Provider, { value: { onSelectionPathSelected: onSelectionPathSelected } },
            React.createElement("aside", { "data-selected-path": state.selection, "data-testid": 'sidenav-root' }, props.children))));
};
